##/usr/bin/python
# -*- coding: utf-8 -*-
#
# Copyright (C) Big-Cat Software Association, 2007.
#
# GILDE project.
# (Graphical Interfaces to Learn Debian Easily)
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at your
# option) any later version. Please read the COPYING file.
#

import sys

from qt import *


from time import sleep

from ifupdown_ui import ifupdown_Ui
from myprocess import *


class ifupdownMain(ifupdown_Ui):

    def __init__(self):
        ifupdown_Ui.__init__(self)

# Active interface name
        iface_line=self.shellcommand3("cat /proc/net/wireless")#[0:]

        pfilter=re.compile('[-a-z0-9]+:')
        iface_pre=pfilter.search(iface_line)
        self.interface=iface_pre.group()[0:-1].strip()

        self.textEdit1.setText("Active interface: ["+self.interface+"]")


    def ifUpSlot(self):

        self.currentprocess = MyProcess(self.textEdit1, "/", ("ifup", self.interface), "", "normal")

        self.currentprocess.thread.process.connect(self.currentprocess.thread.process, SIGNAL("processExited()"), self.processExited)

    def ifDownSlot(self):

        self.currentprocess = MyProcess(self.textEdit1, "/", ("ifdown", self.interface), "", "normal")

        self.currentprocess.thread.process.connect(self.currentprocess.thread.process, SIGNAL("processExited()"), self.processExited)


    def cancelProcess(self):
        self.currentprocess.cancelProcess()


    def processExited(self):
        print "Ifup/ifdown exited."
        try:
            self.cancelProcess()
        except:
            pass
        sleep(5)
        self.close()

    def quitSlot(self):
        try:
            self.cancelProcess()
        except:
            pass
        self.close()


#-----------------------------------------------------------------------------------------
#  extract interface info from shell command output
#-----------------------------------------------------------------------------------------

    def shellcommand3(self, cmdline):
#        self.cmdline = cmdline
        sys.stdout.flush()
        shellin,shellout = os.popen4(cmdline)
        outputline = shellout.readlines()
        try:
            print outputline[2]
            return outputline[2]
        except:
            print "NOT FOUND"
            return "NONE"




def main(args):
    qapptitle=['Wireless Manager Pro 1.0']
    print args
    app=QApplication(qapptitle)
    win=ifupdownMain()
#    win.setMinimumSize(QSize(600,600))
    win.show()
    app.connect(app, SIGNAL("lastWindowClosed()"), app , SLOT("quit()"))
    app.exec_loop()

if __name__=="__main__":
    main(sys.argv)
