##/usr/bin/python
# -*- coding: utf-8 -*-
#
# Copyright (C) Big-Cat Software Association, 2007.
#
# GILDE project.
# (Graphical Interfaces to Learn Debian Easily)
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at your
# option) any later version. Please read the COPYING file.
#

#import tempfile, shutil
import os, sys, re, string

from qt import *
from time import sleep


from kwifipropertiesbase import KWiFiPropertiesBase
from myprocess import *


class KWiFiProperties(KWiFiPropertiesBase):

    modes = ['Auto', 'Ad-Hoc', 'Managed', 'Master', 'Repeat', 'Second', 'Monitor']


    def __init__(self):
        KWiFiPropertiesBase.__init__(self)

        self.user_guifirc=os.path.expanduser("~/.kwirelesstoolspro/.guifirc")
        print self.user_guifirc

        if not os.path.exists(self.user_guifirc):
            QMessageBox.information(None, "Missing Configuration File", "Please use the 'Manage Connections'\nin order to create a basic configuration file!\n(Click on the 'Up', 'Scan' and 'Save' buttons!)", QMessageBox.Ok)
            sys.exit(1)

        if not os.path.exists("/etc/network/interfaces"):
            QMessageBox.information(None, "Missing Configuration File", "Debian type Wireless Tools configuration file not found.\nPlease check your installation!\nYou cannot use this module on your system.", QMessageBox.Ok)
            sys.exit(1)


        iface_line=self.shellcommand3("cat /proc/net/wireless")#[0:]
        print "iface_line, name:"
        print iface_line

        pfilter=re.compile('[-a-z0-9]+:')

        iface_pre=pfilter.search(iface_line)

        ifaceName=iface_pre.group()[0:-1].strip()
        print ifaceName

        self.comboBoxIface.insertItem(ifaceName)

# Filling out lineedit fileds tab pages Network and Security
        self.readguifirc()

        self.essidChangedSlot()


#str(self.comboBoxEssid.currentText())


    def dhcptoggledSlot(self):
        if self.checkBoxDHCP.isChecked():
            self.groupBoxIpconfig.setChecked(0)
        else:
            self.groupBoxIpconfig.setChecked(1)


    def statictoggledSlot(self):
        if self.groupBoxIpconfig.isChecked():
            self.checkBoxDHCP.setChecked(0)
        else:
            self.checkBoxDHCP.setChecked(1)

    def helpSlot(self):
        os.system("khelpcenter /usr/share/doc/kde/HTML/en/kwireless-tools-pro/index.html &")

#    def cancelProcess(self):
#        self.currentprocess.cancelProcess()


#    def quitSlot(self):
#        self.close()

#-----------------------------------------------------------------------------------------
#  for  one-line-output shell commands
#-----------------------------------------------------------------------------------------

    def shellcommand(self, cmdline):
#        self.cmdline = cmdline
        sys.stdout.flush()
        shellin,shellout = os.popen4(cmdline)
        outputline = shellout.readline()
        print outputline
        return outputline

#-----------------------------------------------------------------------------------------
#  extract interface info from shell command output
#-----------------------------------------------------------------------------------------

    def shellcommand3(self, cmdline):
#        self.cmdline = cmdline
        sys.stdout.flush()
        shellin,shellout = os.popen4(cmdline)
        outputline = shellout.readlines()
        try:
            print outputline[2]
            return outputline[2]
        except:
            print "NOT FOUND"
            return " NONE:"






    def readguifirc(self):
#    os.chdir(sourcedir)
#    os.chdir("debian")
#        self.rc_raws=[]
        rcfile=open(self.user_guifirc, "r")
        self.rc_raws=rcfile.readlines()
        rcfile.close()


#    pkg_name=""

        for line in self.rc_raws:
            if line[0:6]=="essid=":
# first element, index 0 is Source (name), split new line:
                self.comboBoxEssid.insertItem(line[6:-1])

#            pkg_name=line[8:-1]
#                break

    def essidChangedSlot(self):

        self.clearLines()

        print "Essid changed, current index:"
        currentindex=self.comboBoxEssid.currentItem()

        match_flag=0
        mac_counter=-1

        for line in self.rc_raws:
#            if mac_counter==currentindex:
            print "---------------"

            if line[0:1]=="[":
                mac_counter=mac_counter+1

            if line[0:1]=="[" and mac_counter==currentindex:
                print "line match"
                self.lineEditMAC.setText(line[1:-2])
                match_flag=1

            elif mac_counter>currentindex:
                print "break: mac_counter>currentindex"
                print mac_counter
                print currentindex
                break

            elif match_flag==1:
                print "match flag"
                print line
                if line[0:3]=="ip=":
                    self.lineEditIP.setText(line[3:-1])

                if line[0:5]=="mask=":
                    self.lineEditNetmask.setText(line[5:-1])

                if line[0:3]=="gw=":
                    self.lineEditGateway.setText(line[3:-1])

                if line[0:4]=="dns=":
                    self.lineEditDNS.setText(line[4:-1])

                if line[0:5]=="wep1=":
                    self.lineEditWEP1.setText(line[5:-1])

                if line[0:5]=="wep2=":
                    self.lineEditWEP2.setText(line[5:-1])

                if line[0:5]=="wep3=":
                    self.lineEditWEP3.setText(line[5:-1])

                if line[0:5]=="wep4=":
                    self.lineEditWEP4.setText(line[5:-1])

# Setup checks

# Ell!!!: guifirc

                if line[0:-1]=="auto=1":
                    self.checkBoxAutoconnect.setChecked(1)

                if self.lineEditIP.text()=="":
                    self.checkBoxDHCP.setChecked(1)
                    self.groupBoxIpconfig.setChecked(0)
                else:
                    self.groupBoxIpconfig.setChecked(1)
                    self.checkBoxDHCP.setChecked(0)

                if self.lineEditWEP1.text()=="" and self.lineEditWEP2.text()=="" and self.lineEditWEP3.text()=="" and self.lineEditWEP4.text()=="" :
                    self.groupBoxWEP.setChecked(0)
                else:
                    self.groupBoxWEP.setChecked(1)

            else:
                pass



    def saveSlot(self):
        ifaceName=self.comboBoxIface.currentText()
        r = QMessageBox.question(self, "System file overwrite",
            "All of the wireless options will be overwritten\nfor interface '%s' if you proceed!\nA backup file will be created.\n\n Are you sure?\n" % ifaceName,
            "&Yes", "&No")
        if r == 1:
#            pass
            return
        if r == 0:
            print "Yes choosed"
            self.rewriteInterfaces()
            return




    def rewriteInterfaces(self):

        ifaceName=str(self.comboBoxIface.currentText())

        os.chdir("/etc/network")

        try:
            os.remove("interfaces.old")
        except os.error:
            pass

        os.rename("interfaces", "interfaces.old")

        interfacesfile=open("interfaces.old", "r")
        interfaces_raws=interfacesfile.readlines()
        interfacesfile.close()

        new_interfaces_raws=[]

        in_flag=0


        for line in interfaces_raws:

            concerntoIface=line.count(ifaceName)

            ifaceLine=line.count("iface")

            if concerntoIface>0 and ifaceLine>0:
                in_flag=1

                print "Concerns to iface and iface raw:"
                print line
                print "deleting raw"

            elif ifaceLine>0:
                in_flag=0
            if in_flag==0 and concerntoIface==0:
                new_interfaces_raws.append(line)

# Append iface properties to file:

# Info:
        new_interfaces_raws.append("#                   - ["+ifaceName+"] -\n" )
        new_interfaces_raws.append("# Created by KWireless Tools Pro for interface ["+ifaceName+"]\n" )

# If auto
        if self.checkBoxAutoconnect.isChecked():
            new_interfaces_raws.append("auto "+ifaceName+"\n")

# If static
        if self.groupBoxIpconfig.isChecked():
            new_interfaces_raws.append("iface "+ifaceName+" inet static\n")
        else:
            new_interfaces_raws.append("iface "+ifaceName+" inet dhcp\n")

# Pre-up commands maybe here is correct
#        if self.groupBoxPreUp.isChecked():
#            if not self.lineEditPreup1.text()=="":
#                new_interfaces_raws.append("pre-up "+self.lineEditPreup1.text()+"\n")
#            if not self.lineEditPreup2.text()=="":
#                new_interfaces_raws.append("pre-up "+self.lineEditPreup2.text()+"\n")

# If spoof
        if self.groupBoxPreUp_2.isChecked():
            new_interfaces_raws.append("pre-up ifconfig "+ifaceName+" down hw ether "+self.lineEditlineEditSpoofMAC.text()+"\n")

# If static, nameserver
        if self.groupBoxIpconfig.isChecked():
            new_interfaces_raws.append("pre-up echo nameserver "+self.lineEditDNS.text()+" > /etc/resolv.conf\n")

# Up and ESSID:
        new_interfaces_raws.append("pre-up ifconfig "+ifaceName+" up\n")
        new_interfaces_raws.append("pre-up iwconfig "+ifaceName+" essid "+self.comboBoxEssid.currentText()+"\n")

# WEP keys:
        if self.groupBoxWEP.isChecked():
            if not self.lineEditWEP1.text()=="":
                new_interfaces_raws.append("pre-up iwconfig "+ifaceName+" key [1] "+self.lineEditWEP1.text()+"\n")
                if self.radioButtonWEP1.isChecked():
                    new_interfaces_raws.append("pre-up iwconfig "+ifaceName+" key [1]\n")

            if not self.lineEditWEP2.text()=="":
                new_interfaces_raws.append("pre-up iwconfig "+ifaceName+" key [2] "+self.lineEditWEP2.text()+"\n")
                if self.radioButtonWEP2.isChecked():
                    new_interfaces_raws.append("pre-up iwconfig "+ifaceName+" key [2]\n")

            if not self.lineEditWEP3.text()=="":
                new_interfaces_raws.append("pre-up iwconfig "+ifaceName+" key [3] "+self.lineEditWEP3.text()+"\n")
                if self.radioButtonWEP3.isChecked():
                    new_interfaces_raws.append("pre-up iwconfig "+ifaceName+" key [3]\n")

            if not self.lineEditWEP4.text()=="":
                new_interfaces_raws.append("pre-up iwconfig "+ifaceName+" key [4] "+self.lineEditWEP4.text()+"\n")
                if self.radioButtonWEP4.isChecked():
                    new_interfaces_raws.append("pre-up iwconfig "+ifaceName+" key [4]\n")

# Pre-up commands
        if self.groupBoxPreUp.isChecked():
            if not self.lineEditPreup1.text()=="":
                new_interfaces_raws.append("pre-up "+self.lineEditPreup1.text()+"\n")
            if not self.lineEditPreup2.text()=="":
                new_interfaces_raws.append("pre-up "+self.lineEditPreup2.text()+"\n")
# Up commands
        if self.groupBoxUp.isChecked():
            if not self.lineEditUp1.text()=="":
                new_interfaces_raws.append("up "+self.lineEditUp1.text()+"\n")
            if not self.lineEditUp2.text()=="":
                new_interfaces_raws.append("up "+self.lineEditUp2.text()+"\n")
# Pre-down commands
        if self.groupBoxPreDown.isChecked():
            if not self.lineEditPredown1.text()=="":
                new_interfaces_raws.append("down "+self.lineEditPredown1.text()+"\n")
            if not self.lineEditPredown2.text()=="":
                new_interfaces_raws.append("down "+self.lineEditPredown2.text()+"\n")
# Down commands
        if self.groupBoxDown.isChecked():
            if not self.lineEditDown1.text()=="":
                new_interfaces_raws.append("post-down "+self.lineEditDown1.text()+"\n")
            if not self.lineEditDown2.text()=="":
                new_interfaces_raws.append("post-down "+self.lineEditDown2.text()+"\n")

# If static, addresses
        if self.groupBoxIpconfig.isChecked():
            new_interfaces_raws.append("    address "+self.lineEditIP.text()+"\n")
            new_interfaces_raws.append("    netmask "+self.lineEditNetmask.text()+"\n")
            new_interfaces_raws.append("    gateway "+self.lineEditGateway.text()+"\n")



#    print new_interfaces_raws to interfaces file
        new_interfacesfile=open("interfaces", "w")
        new_interfacesfile.writelines(new_interfaces_raws)
        new_interfacesfile.close()



    def clearLines(self):

        self.lineEditIP.clear()
        self.lineEditNetmask.clear()
        self.lineEditGateway.clear()
        self.lineEditDNS.clear()
        self.lineEditWEP1.clear()
        self.lineEditWEP2.clear()
        self.lineEditWEP3.clear()
        self.lineEditWEP4.clear()







def main(args):
    qapptitle=['Wireless Manager Pro 1.0']
    print args

    app=QApplication(qapptitle)
    win=KWiFiProperties()
#    win.setMinimumSize(QSize(600,600))
    win.show()
    app.connect(app, SIGNAL("lastWindowClosed()"), app , SLOT("quit()"))
    app.exec_loop()





if __name__=="__main__":
    main(sys.argv)
