##/usr/bin/python
# -*- coding: utf-8 -*-
#
# Copyright (C) Big-Cat Software Association, 2007.
#
# GILDE project. 
# (Graphical Interfaces to Learn Debian Easily)
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at your
# option) any later version. Please read the COPYING file.
#

import sys
from qt import *

from monitor import *


class MonitorWindow(QMainWindow):



    def __init__(self, *args):
        apply(QMainWindow.__init__, (self, None, "mzujabb") + args)

        self.setName("main window")
        self.mainWidget=QWidget(self)

        self.setCentralWidget(self.mainWidget)
        self.mainLayout=QVBoxLayout(self.mainWidget, 0, 0, "main")


        self.widgetDialog=WirelessPlot(self.mainWidget)
        self.widgetDialog.setFixedSize(700,450)
        self.widgetDialog.setTitle("Continuous read")
        self.widgetDialog.setMargin(5)

        self.mainLayout.addWidget(self.widgetDialog)

# Close button
        self.pushButton1 = QPushButton(self,"pushButton1")
        self.pushButton1.setGeometry(QRect(560,330,135,30))
        self.pushButton1.setText(self.__tr("Close"))
        self.connect(self.pushButton1,SIGNAL("clicked()"),self.close)


# Midscale button
        self.pushButton2 = QPushButton(self,"pushButton2")
        self.pushButton2.setGeometry(QRect(560,270,135,30))
        self.pushButton2.setText(self.__tr("Set Midscale"))
        self.connect(self.pushButton2,SIGNAL("clicked()"),self.slotMidScale)

    def slotMidScale(self):
        self.axisScale=2*self.widgetDialog.data["LinkQuality"][0]
        if self.axisScale>10:
            print self.axisScale
            self.widgetDialog.setAxisScale(QwtPlot.yLeft, 0, self.axisScale)
        else:
            self.widgetDialog.setAxisScale(QwtPlot.yLeft, 0, 10)





    def languageChange(self):
        self.setCaption(self.__tr("Help"))
        self.pushButton1.setText(self.__tr("Close"))


    def __tr(self,s,c = None):
        return qApp.translate("Help",s,c)



def main(args):
    qapptitle=['KWireless Tools Pro 1.0']
    print args
    app=QApplication(qapptitle)
    win=MonitorWindow()
    win.setFixedSize(QSize(700,450))
    win.show()
    app.connect(app, SIGNAL("lastWindowClosed()"), app , SLOT("quit()"))
    app.exec_loop()

if __name__=="__main__":
    main(sys.argv)
